CREATE OR REPLACE TRIGGER TR_TASKACTORPOOL
AFTER DELETE
    ON JBPM_TASKACTORPOOL
FOR EACH ROW    
BEGIN
   delete from JBPM_POOLEDACTOR where ID_ = :OLD.POOLEDACTOR_ ;  
END TR_TASKACTORPOOL;

COMMIT;

UPDATE JBPM_PROCESSINSTANCE SET ROOTTOKEN_ = NULL 
                          WHERE TRUNC (END_) <= TRUNC (SYSDATE) - 45
                            AND END_ IS NOT NULL;

DELETE FROM JBPM_TASKACTORPOOL 
      WHERE TASKINSTANCE_ IN (
                      SELECT ID_ 
                        FROM JBPM_TASKINSTANCE 
                       WHERE PROCINST_  IN (
                                    SELECT ID_  
                                      FROM JBPM_PROCESSINSTANCE 
                                     WHERE TRUNC (END_) <= TRUNC (SYSDATE) - 45
                                       AND END_ IS NOT NULL)); 


DELETE FROM JBPM_TASKINSTANCE 
      WHERE PROCINST_  IN (
                   SELECT ID_ 
                     FROM JBPM_PROCESSINSTANCE 
                    WHERE TRUNC (END_) <= TRUNC (SYSDATE) - 45
                      AND END_ IS NOT NULL);
        
DELETE FROM JBPM_VARIABLEINSTANCE 
      WHERE TOKEN_  IN (
                SELECT ID_  
                  FROM JBPM_TOKEN 
                 WHERE PROCESSINSTANCE_ IN (
                                    SELECT ID_  
                                      FROM JBPM_PROCESSINSTANCE  
                                     WHERE TRUNC (END_) <= TRUNC (SYSDATE) - 45
                                       AND END_ IS NOT NULL));   
                                       
DELETE FROM JBPM_TOKENVARIABLEMAP 
      WHERE TOKEN_  IN (
                SELECT ID_ 
                  FROM JBPM_TOKEN 
                 WHERE PROCESSINSTANCE_ IN (
                                    SELECT ID_ 
                                      FROM JBPM_PROCESSINSTANCE 
                                     WHERE TRUNC (END_) <= TRUNC (SYSDATE) - 45
                                       AND END_ IS NOT NULL));
                                       
UPDATE JBPM_TOKEN SET PARENT_ = NULL  
                WHERE PROCESSINSTANCE_ IN (
                                   SELECT ID_ 
                                     FROM JBPM_PROCESSINSTANCE                     
                                    WHERE TRUNC (END_) <= TRUNC (SYSDATE) - 45
                                      AND END_ IS NOT NULL);                                       

DELETE FROM JBPM_TOKEN 
      WHERE PROCESSINSTANCE_ IN (
                         SELECT ID_ 
                           FROM JBPM_PROCESSINSTANCE                     
                          WHERE TRUNC (END_) <= TRUNC (SYSDATE) - 45
                            AND END_ IS NOT NULL);

DELETE FROM JBPM_MODULEINSTANCE 
      WHERE PROCESSINSTANCE_ IN (
                         SELECT ID_ 
                           FROM JBPM_PROCESSINSTANCE                     
                          WHERE TRUNC (END_) <= TRUNC (SYSDATE) - 45
                            AND END_ IS NOT NULL);

DELETE FROM JBPM_PROCESSINSTANCE                     
      WHERE TRUNC (END_) <= TRUNC (SYSDATE) - 45
        AND END_ IS NOT NULL;  
        
COMMIT;                                                   